## gle-graphics 4.3.9

=== src/CMakeLists.txt ===
#
# -- CMakeLists.txt for GLE - Graphics Layout Engine
#
cmake_minimum_required (VERSION 3.25)
cmake_policy(SET CMP0091 NEW) 	# windows static runtimes selection
cmake_policy(SET CMP0074 NEW)	# uses <PackageName>_ROOT variables.
if(POLICY CMP0144)
  cmake_policy(SET CMP0144 NEW)  # upper case pacakge root variables
endif()

project( gle-graphics VERSION 4.3.9 LANGUAGES CXX C)
enable_language(CXX)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CMakePrintHelpers)
include(GNUInstallDirs)
if(UNIX AND NOT APPLE)
# needed for making .deb package
include(InstallRequiredSystemLibraries)
endif()

find_package(ECM CONFIG NO_MODULE) # optional extra-cmake-modules needed for find_poppler
if(ECM_FOUND)
	list(INSERT CMAKE_MODULE_PATH 0 ${ECM_MODULE_PATH})
endif()

set( CMAKE_OSX_DEPLOYMENT_TARGET "10.15" CACHE STRING "Minimum OS X deployment version")	# minimum supported by apple

add_compile_definitions(GLEVN="${PROJECT_VERSION}")
set( CMAKE_DEBUG_POSTFIX  "d")
#
# -- options
#
set(BUILD_MANIP_DEFAULT ON)
if(WIN32)
	# Disable manip build on Windows due to compatibility issues
	set(BUILD_MANIP_DEFAULT OFF)
endif()
#message("CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}")
#message("DATAROOTDIR ${CMAKE_INSTALL_DATAROOTDIR}")
#message("BINDIR ${CMAKE_INSTALL_BINDIR}")
#message("DOCDIR ${CMAKE_INSTALL_DOCDIR}")
#message("DOCDIR ${CMAKE_INSTALL_DOCDIR}")
option(BUILD_GUI "Build the GUI - gle Previewer" ON)
option(BUILD_MANIP "Build manip program" ${BUILD_MANIP_DEFAULT})
option(BUILD_GLEBTOOL "Build glebtool program - deprecated" OFF)
option(INSTALL_FBUILD "Install the fbuild program - only needed during gle build phase" OFF)
option(INSTALL_MAKEFMT "Install the makefmt program - only needed during gle build phase" OFF)
option(MSVC_USE_STATIC_RUNTIME "Build and link against the windows static runtime (/MT) (windows only)" OFF)
option(GLE_EXAMPLES_LIBRARY_PATH "Path to gle-examples.  Only needed when using cpack to build distributables" "./gle-examples")
option(GLE_USER_MANUAL_PATH "Path to gle-manual when gle-manual.pdf resides.  Only needed when using cpack to build distributables" "./gle-manual")
option(DEVELOPER_INSTALLATION "Linux only: Install all files in staging area, otherwise install in FHS paths on system." OFF)
option(BUILD_TESTS "Build Testing Programs." OFF)
option(INSTALL_TESTS "Install Testing Programs." OFF)
option(INSTALL_EXAMPLES "Install examples from gle-library defined by EXAMPLES_TO_INSTALL." OFF)
option(CONSOLE_COLORS "Use ANSI color codes for console output." ON)
option(INSTALL_CREATE_FILETYPE_ASSOCIATION "Create filetype association for .gle files during installation phase" OFF)
#
# -- List names of examples to include from gle-library in installation and distributable packages
#
set(EXAMPLES_TO_INSTALL "hello_world" "scatter_plot" "bar_chart" "math_mode_plot" "polar_plot" "fitting" "pythagorean" "semitrans")

if(NOT DEFINED POPPLER_INTERFACE)
	# poppler interface defaults if not set -> CPP for Windows, GLIB for Linux and Apple/Darwin
	# CPP interface to poppler is *more* cross platform and does not rely on GLIB2.
	# vcpkg only installs the cpp interface for windows
	set(POPPLER_INTERFACE_DEFAULT "CPP")
	if(UNIX OR APPLE)
		set(POPPLER_INTERFACE_DEFAULT "GLIB")
	endif()
	set(POPPLER_INTERFACE ${POPPLER_INTERFACE_DEFAULT} CACHE STRING "The poppler (PDFLibarary) interface to utilize GLIB or CPP")
endif()
#
# -- Windows option for static runtimes
#
if(WIN32)
	#
	# -- Windows option for runtime library - assume DLL /MD unless MSVC_USE_STATIC_RUNTIME=ON then use static /MT
	#
	set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
	if(DEFINED MSVC_USE_STATIC_RUNTIME AND MSVC_USE_STATIC_RUNTIME)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
		# tag CPACK_SYSTEM_NAME with "s" to denote static runtime - must rebuild the whole name as there is no way to add a tag
		set(CPACK_SYSTEM_NAME "win64s")
		if(${CMAKE_VS_PLATFORM_NAME} STREQUAL "Win32")
			set(CPACK_SYSTEM_NAME "win32s")
		endif()
	endif()
endif()
if (POLICY CMP0069)
	# link-time or inter-process optimization LTO or IPO
	cmake_policy(SET CMP0069 NEW)
	include(CheckIPOSupported)
	check_ipo_supported(RESULT IPO_SUPPORTED)
	if ( IPO_SUPPORTED )
		message(STATUS "LTO/IPO Supported - Turning On")
		# only set for release builds - this will apply to all targets: .obj, .exe, .so, .dll, .lib, .a
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE ON)
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_DEBUG OFF)
	endif()
endif()
#
# -- cpack information
#
set(CPACK_PACKAGE_VENDOR "GLE")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_VERBATIM_VARIABLES true)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "GLE Graphics Programming Language")
#set(CPACK_PACKAGE_DESCRIPTION_FILE )
#set(CPACK_RESOURCE_FILE_WELCOME )
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../doc/LICENSE.txt")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/../doc/README.txt")
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${PROJECT_NAME})
#
# - NSIS specific settings
#
set(CPACK_NSIS_COMPRESSOR "lzma")
set(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}/gui/images\\gle.ico")
set(CPACK_NSIS_MUI_UNIICON "${CMAKE_CURRENT_SOURCE_DIR}/gui/images\\gle.ico")
set(CPACK_NSIS_MUI_HEADERIMAGE "${CMAKE_CURRENT_SOURCE_DIR}/../graphics\\nsis_banner_image.bmp")
set(CPACK_NSIS_MUI_WELCOMEFINISHPAGE_BITMAP "${CMAKE_CURRENT_SOURCE_DIR}/../graphics\\nsis_welcome_image.bmp")
set(CPACK_NSIS_WELCOME_TITLE "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_BRANDING_TEXT "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_DISPLAY_NAME "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL OFF)
set(CPACK_NSIS_MODIFY_PATH ON)
set(CPACK_PACKAGE_EXECUTABLES 	"qgle" "GLE Previewer"  )
set(CPACK_NSIS_MENU_LINKS
	"doc/gle-manual.pdf" "GLE Manual"
	"https://glx.sourceforge.io" "GLE Web Site"
	"https://github.com/vlabella/GLE" "GLE GitHub page"
)
# extra commands include finddeps and setting file associations
set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
	Exec \"$INSTDIR\\bin\\qgle.exe -finddeps '$INSTDIR\\glerc.old'\"
	WriteRegStr HKCR '.gle' '' 'GLEFile'
  WriteRegStr HKCR 'GLEFile' '' 'GLE Script'
  WriteRegStr HKCR 'GLEFile\\DefaultIcon' '' '$INSTDIR\\bin\\qgle.exe,0'
  WriteRegStr HKCR 'GLEFile\\shell\\open\\command' '' '$INSTDIR\\bin\\qgle.exe \"%1\"'
  WriteRegStr HKCR 'GLEFile\\shell\\edit' '' 'Edit GLE Script'
  WriteRegStr HKCR 'GLEFile\\shell\\edit\\command' '' '$INSTDIR\\bin\\qgle.exe \"%1\"'
  System::Call 'Shell32::SHChangeNotify(i 0x8000000, i 0, i 0, i 0)'
")
set (CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "
	DeleteRegKey HKCR '.gle'
  DeleteRegKey HKCR 'GLEFile'
")
#
# -- Debian package specific settings
#
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_DEBIAN_PACKAGE_SECTION "graphics")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Vincent LaBella")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "GLE Graphics Layout Engine")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "glx.sourceforge.io")
set(CPACK_DEBIAN_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
#
# -- wix specific settings unused no .msi generated
# dont change these GUIDs once generated
#set(CPACK_WIX_UPGRADE_GUID "" )
#set(CPACK_WIX_PRODUCT_GUID "" )
#set(CPACK_WIX_PRODUCT_ICON "")
#
# -- DragNDrop MacOS dmg settings
#
set(CPACK_DMG_FORMAT "UDBZ")

include(CPack)
#
# -- create text file with version information in it for reading in a makefile
#
string(TOLOWER ${CMAKE_PROJECT_NAME} CMAKE_PROJECT_NAME_LC )
FILE(WRITE
${CMAKE_CURRENT_SOURCE_DIR}/../project_info.mak
"#\n"
"# -- project_info.mak - Auto generated by CmakeLists.txt\n"
"#    DO NOT EDIT - ALL CHANGES WILL BE LOST\n"
"#\n"
"PROJECT_NAME		=${CMAKE_PROJECT_NAME}\n"
"PROJECT_NAME_LC		=${CMAKE_PROJECT_NAME_LC}\n"
"SYSTEM_NAME 		=${CPACK_SYSTEM_NAME}\n"
"VERSION_NUMBER		=${PROJECT_VERSION}\n"
"PACKAGE_BASE		=\$(PROJECT_NAME)-\$(VERSION_NUMBER)\n"
"PACKAGE_BASENAME	=\$(PACKAGE_BASE)-\$(SYSTEM_NAME)\n"
)
#
# -- external libraries user can pass ***_ROOT to modify search location
#
find_package(ZLIB REQUIRED)
SET(Boost_USE_STATIC_LIBS ON)
find_package(Boost CONFIG)
find_package(JPEG)
if(BUILD_MANIP)
	# manip needs curses or pdcurses on windows
	if(UNIX OR APPLE)
		find_package(Curses REQUIRED)
	else()
		set(CURSES_FOUND)
		get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
		if(_isMultiConfig)
			find_library(CURSES_RELEASE NAMES pdcurses PATHS ${CURSES_ROOT} PATH_SUFFIXES lib lib64 )
			string(COMPARE NOTEQUAL "${CURSES_RELEASE}" "CURSES_RELEASE-NOTFOUND" CURSES_FOUND)
			find_library(CURSES_DEBUG NAMES pdcursesd PATHS ${CURSES_ROOT} PATH_SUFFIXES lib lib64 )
			set(HAS_DEBUG )
			string(COMPARE NOTEQUAL "${CURSES_DEBUG}" "CURSES_DEBUG-NOTFOUND" HAS_DEBUG)
			if(HAS_DEBUG)
				list(APPEND CURSES_LIBRARIES "optimized")
				list(APPEND CURSES_LIBRARIES ${CURSES_RELEASE})
				list(APPEND CURSES_LIBRARIES "debug")
				list(APPEND CURSES_LIBRARIES ${CURSES_DEBUG})
			else()
				list(APPEND CURSES_LIBRARIES ${CURSES_RELEASE})
			endif()
		else()
			find_library(CURSES_LIBRARIES NAMES pdcurses pdcursesd PATHS ${CURSES_ROOT} PATH_SUFFIXES lib lib64 )
			string(COMPARE NOTEQUAL "${CURSES_LIBRARIES}" "CURSES_LIBRARIES-NOTFOUND" CURSES_FOUND)
		endif()
		find_path(CURSES_INCLUDE_DIRS curses.h PATHS ${CURSES_ROOT} PATH_SUFFIXES include include/pdcurses )
		if(CURSES_FOUND)
			message(STATUS "Found LIBCURSES: ${CURSES_LIBRARIES}" )
		endif()
	endif()
endif()
find_package(TIFF)

if(WIN32 AND TIFF_FOUND)
	#
	# -- find optional packages for LibTIFF only if linking against static libraries on windows
	#
	find_package(LibLZMA) # -- for libTIFF optional
	find_package(JBIG QUIET) # -- for libtiff optional
	if(JBIG_FOUND)
		message(STATUS "Found JBIG" )
	endif()
	find_package(ZSTD) # -- for libtiff optional
	if(ZSTD_FOUND)
		message(STATUS "Found ZSTD" )
	endif()
	#
	# -- libdeflate for libtiff - optional
	#
	set(DEFLATE_FOUND)
	get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
	if(_isMultiConfig)
		find_library(DEFLATE_RELEASE NAMES libdeflate libdeflatestatic PATHS ${DEFLATE_ROOT} PATH_SUFFIXES lib )
		string(COMPARE NOTEQUAL "${DEFLATE_RELEASE}" "DEFLATE_RELEASE-NOTFOUND" DEFLATE_FOUND)
		find_library(DEFLATE_DEBUG NAMES defalted libdeflatestaticd PATHS ${DEFLATE_ROOT} PATH_SUFFIXES lib )
		set(HAS_DEBUG )
		string(COMPARE NOTEQUAL "${DEFLATE_DEBUG}" "DEFLATE_DEBUG-NOTFOUND" HAS_DEBUG)
		if(HAS_DEBUG)
			list(APPEND DEFLATE_LIBRARIES "optimized")
			list(APPEND DEFLATE_LIBRARIES ${DEFLATE_RELEASE})
			list(APPEND DEFLATE_LIBRARIES "debug")
			list(APPEND DEFLATE_LIBRARIES ${DEFLATE_DEBUG})
		else()
			list(APPEND DEFLATE_LIBRARIES ${DEFLATE_RELEASE})
		endif()
	else()
		find_library(DEFLATE_LIBRARIES NAMES deflate deflated libdeflate.a libdeflated.a PATHS ${DEFLATE_ROOT} PATH_SUFFIXES lib )
		string(COMPARE NOTEQUAL "${DEFLATE_LIBRARIES}" "DEFLATE_LIBRARIES-NOTFOUND" DEFLATE_FOUND)
	endif()
	find_path(DEFLATE_INCLUDE_DIRS libdeflate.h PATHS ${DEFLATE_ROOT} PATH_SUFFIXES include )
	if(DEFLATE_FOUND)
		message(STATUS "Found LIBDEFLATE: ${DEFLATE_LIBRARIES}" )
	endif()
endif()
# note findPNG calls findZLIB
find_package(PNG )
# find debug if it exists for multi config generators only
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
	find_library(PNG_DEBUG NAMES pngd libpngd PATHS ${PNG_ROOT} PATH_SUFFIXES lib )
	if(NOT ${PNG_DEBUG} STREQUAL "PNG_DEBUG-NOTFOUND" )
		list(INSERT PNG_LIBRARIES 0 "optimized")
		list(APPEND PNG_LIBRARIES "debug")
		list(APPEND PNG_LIBRARIES ${PNG_DEBUG})
	endif()
endif()
#find_package(Cairo )
#find_package(Pixman )
#
# -- cairo library - cmake does not supply findCAIRO.cmake
#
set(CAIRO_FOUND )
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
	find_library(CAIRO_RELEASE NAMES cairo PATHS ${CAIRO_ROOT} PATH_SUFFIXES lib REQUIRED )
