=== debian/changelog ===
gle-graphics (4.3.9-2) unstable; urgency=medium

  * Disable building of manip.
  * Remove trailing whitespace from d/changelog.
  * Use secure URL for Homepage.

 -- Christian T. Steigies <cts@debian.org>  Sun, 08 Feb 2026 16:07:31 +0100

gle-graphics (4.3.9-1) unstable; urgency=medium

  * New upstream release.
  * Remove patches that are included upstream.
  * Stop creating libgs search path header file.
  * Remove qt6-5compat-dev from Build-Depends.
  * Update Standards-Version to 4.7.3 (no changes)

 -- Christian T. Steigies <cts@debian.org>  Sun, 25 Jan 2026 18:12:12 +0100
